Index: CKEditor/branches/versions/3.3.x/_source/adapters/jquery.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/adapters/jquery.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/adapters/jquery.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/core/ckeditor_base.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/ckeditor_base.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/ckeditor_base.js	(revision 5306)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -137,4 +137,7 @@
 				}
 
+				if( !path )
+						throw 'The CKEditor installation path could not be automatically detected. Please set the global variable "CKEDITOR_BASEPATH" before creating editor instances.'
+
 				return path;
 			})(),
Index: CKEditor/branches/versions/3.3.x/_source/core/ckeditor_basic.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/ckeditor_basic.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/ckeditor_basic.js	(revision 5306)
@@ -81,5 +81,5 @@
 		CKEDITOR.replaceByClassEnabled = true;
 
-		var createInstance = function( elementOrIdOrName, config, creationFunction )
+		var createInstance = function( elementOrIdOrName, config, creationFunction, data )
 		{
 			if ( CKEDITOR.env.isCompatible )
@@ -89,5 +89,5 @@
 					CKEDITOR.loadFullCore();
 
-				var editor = creationFunction( elementOrIdOrName, config );
+				var editor = creationFunction( elementOrIdOrName, config, data );
 				CKEDITOR.add( editor );
 				return editor;
@@ -127,4 +127,5 @@
 		 *		editor instance. Configurations set here will override global CKEditor
 		 *		settings.
+		 * @param {String} [data] Since 3.3. Initial value for the instance.
 		 * @returns {CKEDITOR.editor} The editor instance created.
 		 * @example
@@ -133,7 +134,7 @@
 		 * <b>CKEDITOR.appendTo( 'editorSpace' )</b>;
 		 */
-		CKEDITOR.appendTo = function( elementOrId, config )
-		{
-			return createInstance( elementOrId, config, CKEDITOR.editor.appendTo );
+		CKEDITOR.appendTo = function( elementOrId, config, data )
+		{
+			return createInstance( elementOrId, config, CKEDITOR.editor.appendTo, data );
 		};
 
Index: CKEditor/branches/versions/3.3.x/_source/core/commanddefinition.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/commanddefinition.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/commanddefinition.js	(revision 5306)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -85,2 +85,18 @@
  * });
  */
+
+
+/**
+ * Whether the command state should be set to {@link CKEDITOR.TRISTATE_DISABLED} on startup.
+ * @name  CKEDITOR.commandDefinition.startDisabled
+ * @type {Boolean}
+ * @default false
+ * @example
+ * editorInstance.addCommand( 'unlink',
+ * {
+ *     exec : function( editor )
+ *     {
+ *     },
+ *     startDisabled : true    // Command is unavailable until selection is inside a link. 
+ * });
+ */
Index: CKEditor/branches/versions/3.3.x/_source/core/config.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/config.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/config.js	(revision 5306)
@@ -135,4 +135,16 @@
 
 	/**
+	 * Force the respect of {@link CKEDITOR.config.enterMode} as line break regardless of the context,
+	 * E.g. If {@link CKEDITOR.config.enterMode} is set to {@link CKEDITOR.ENTER_P},
+	 * press enter key inside a 'div' will create a new paragraph with 'p' instead of 'div'.
+	 * @since 3.2.1
+	 * @default false
+	 * @example
+	 * // Not recommended.
+	 * config.forceEnterMode = true;
+	 */
+	forceEnterMode : false,
+
+	/**
 	 * Just like the {@link CKEDITOR.config.enterMode} setting, it defines the behavior for the SHIFT+ENTER key.
 	 * The allowed values are the following constants, and their relative
Index: CKEditor/branches/versions/3.3.x/_source/core/dom/comment.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/dom/comment.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/dom/comment.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/core/dom/domobject.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/dom/domobject.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/dom/domobject.js	(revision 5306)
@@ -116,4 +116,24 @@
 				}
 			}
+		},
+
+		/**
+		 * Removes any listener set on this object.
+		 * To avoid memory leaks we must assure that there are no
+		 * references left after the object is no longer needed.
+		 */
+		removeAllListeners : function()
+		{
+			var nativeListeners = this.getCustomData( '_cke_nativeListeners' );
+			for ( eventName in nativeListeners)
+			{
+				var listener = nativeListeners[ eventName ];
+				if ( this.$.removeEventListener )
+					this.$.removeEventListener( eventName, listener, false );
+				else if ( this.$.detachEvent )
+					this.$.detachEvent( 'on' + eventName, listener );
+
+				delete nativeListeners[ eventName ];
+			}
 		}
 	};
@@ -198,4 +218,20 @@
 
 	/**
+	 * Removes any data stored on this object.
+	 * To avoid memory leaks we must assure that there are no
+	 * references left after the object is no longer needed.
+	 * @name CKEDITOR.dom.domObject.prototype.clearCustomData
+	 * @function
+	 */
+	domObjectProto.clearCustomData = function()
+	{
+		// Clear all event listeners
+		this.removeAllListeners();
+
+		var expandoNumber = this.$._cke_expando;
+		expandoNumber && delete customData[ expandoNumber ];
+	};
+
+	/**
 	 * @name CKEDITOR.dom.domObject.prototype.getCustomData
 	 */
Index: CKEditor/branches/versions/3.3.x/_source/core/dom/element.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/dom/element.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/dom/element.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/core/dom/elementpath.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/dom/elementpath.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/dom/elementpath.js	(revision 5306)
@@ -7,5 +7,5 @@
 {
 	// Elements that may be considered the "Block boundary" in an element path.
-	var pathBlockElements = { address:1,blockquote:1,dl:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,p:1,pre:1,li:1,dt:1,de:1 };
+	var pathBlockElements = { address:1,blockquote:1,dl:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,p:1,pre:1,li:1,dt:1,dd:1 };
 
 	// Elements that may be considered the "Block limit" in an element path.
Index: CKEditor/branches/versions/3.3.x/_source/core/dom/range.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/dom/range.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/dom/range.js	(revision 5306)
@@ -926,5 +926,5 @@
 										siblingText = sibling.getText();
 
-										if ( !(/[^\s\ufeff]/).test( siblingText ) )	// Spaces + Zero Width No-Break Space (U+FEFF)
+										if ( (/[^\s\ufeff]/).test( siblingText ) )	// Spaces + Zero Width No-Break Space (U+FEFF)
 											sibling = null;
 										else
@@ -1085,5 +1085,5 @@
 										siblingText = sibling.getText();
 
-										if ( !(/[^\s\ufeff]/).test( siblingText ) )
+										if ( (/[^\s\ufeff]/).test( siblingText ) )
 											sibling = null;
 										else
@@ -1237,4 +1237,96 @@
 
 		/**
+		 *  Descrease the range to make sure that boundaries
+		 *  always anchor beside text nodes or innermost element.
+		 * @param {Number} mode  ( CKEDITOR.SHRINK_ELEMENT | CKEDITOR.SHRINK_TEXT ) The shrinking mode.
+		 */
+		shrink : function( mode )
+		{
+			// Unable to shrink a collapsed range.
+			if ( !this.collapsed )
+			{
+				mode = mode || CKEDITOR.SHRINK_TEXT;
+
+				var walkerRange = this.clone();
+
+				var startContainer = this.startContainer,
+					endContainer = this.endContainer,
+					startOffset = this.startOffset,
+					endOffset = this.endOffset,
+					collapsed = this.collapsed;
+
+				// Whether the start/end boundary is moveable.
+				var moveStart = 1,
+						moveEnd = 1;
+
+				if ( startContainer && startContainer.type == CKEDITOR.NODE_TEXT )
+				{
+					if ( !startOffset )
+						walkerRange.setStartBefore( startContainer );
+					else if ( startOffset >= startContainer.getLength( ) )
+						walkerRange.setStartAfter( startContainer );
+					else
+					{
+						// Enlarge the range properly to avoid walker making
+						// DOM changes caused by triming the text nodes later.
+						walkerRange.setStartBefore( startContainer );
+						moveStart = 0;
+					}
+				}
+				
+				if ( endContainer && endContainer.type == CKEDITOR.NODE_TEXT )
+				{
+					if ( !endOffset )
+						walkerRange.setEndBefore( endContainer );
+					else if ( endOffset >= endContainer.getLength( ) )
+						walkerRange.setEndAfter( endContainer );
+					else
+					{
+						walkerRange.setEndAfter( endContainer );
+						moveEnd = 0;
+					}
+				}
+
+				var walker = new CKEDITOR.dom.walker( walkerRange );
+
+				walker.evaluator = function( node )
+				{
+					return node.type == ( mode == CKEDITOR.SHRINK_ELEMENT ?
+						CKEDITOR.NODE_ELEMENT : CKEDITOR.NODE_TEXT );
+				};
+
+				var currentElement;
+				walker.guard = function( node, movingOut )
+				{
+					// Stop when we're shrink in element mode while encountering a text node.
+					if ( mode == CKEDITOR.SHRINK_ELEMENT && node.type == CKEDITOR.NODE_TEXT )
+						return false;
+
+					// Stop when we've already walked "through" an element.
+					if ( movingOut && node.equals( currentElement ) )
+						return false;
+
+					if ( !movingOut && node.type == CKEDITOR.NODE_ELEMENT )
+						currentElement = node;
+				};
+
+				if ( moveStart )
+				{
+					var textStart = walker[ mode == CKEDITOR.SHRINK_ELEMENT ? 'lastForward' : 'next']();
+					textStart && this.setStartBefore( textStart );
+				}
+
+				if ( moveEnd )
+				{
+					walker.reset();
+					var textEnd = walker[ mode == CKEDITOR.SHRINK_ELEMENT ? 'lastBackward' : 'previous']();
+					textEnd && this.setEndAfter( textEnd );
+				}
+
+				return !!( moveStart || moveEnd );
+			}
+		},
+
+		/**
 		 * Inserts a node at the start of the range. The range will be expanded
 		 * the contain the node.
@@ -1624,4 +1716,8 @@
 			var isEditable;
 
+			// Empty elements are rejected.
+			if ( CKEDITOR.dtd.$empty[ el.getName() ] )
+				return false;
+
 			while ( el && el.type == CKEDITOR.NODE_ELEMENT )
 			{
@@ -1734,2 +1830,6 @@
 CKEDITOR.END = 2;
 CKEDITOR.STARTEND = 3;
+
+CKEDITOR.SHRINK_ELEMENT = 1;
+CKEDITOR.SHRINK_TEXT = 2;
+
Index: CKEditor/branches/versions/3.3.x/_source/core/dom/walker.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/dom/walker.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/dom/walker.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -102,5 +102,5 @@
 				}
 				else
-					node = ( guard ( node ) === false ) ?
+					node = ( guard ( node, true ) === false ) ?
 						null : node.getPreviousSourceNode( true, type, guard );
 			}
@@ -116,5 +116,5 @@
 				}
 				else
-					node = ( guard ( range.startContainer ) === false ) ?
+					node = ( guard ( range.startContainer, true ) === false ) ?
 						null : range.startContainer.getNextSourceNode( true, type, guard ) ;
 			}
Index: CKEditor/branches/versions/3.3.x/_source/core/editor.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/editor.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/editor.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -335,5 +335,5 @@
 		{
 			command = commands[ name ];
-			command[ command.modes[ mode ] ? 'enable' : 'disable' ]();
+			command[ command.startDisabled ? 'disable' : command.modes[ mode ] ? 'enable' : 'disable' ]();
 		}
 	}
@@ -472,5 +472,48 @@
 				this.updateElement();
 
+			if ( this.mode )
+			{
+				// ->		currentMode.unload( holderElement );
+				this._.modes[ this.mode ].unload( this.getThemeSpace( 'contents' ) );
+			}
+
 			this.theme.destroy( this );
+
+			var toolbars,
+				index = 0,
+				j,
+				items,
+				instance;
+
+			if ( this.toolbox )
+			{
+				toolbars = this.toolbox.toolbars;
+				for ( ; index < toolbars.length ; index++ )
+				{
+					items = toolbars[ index ].items;
+					for ( j = 0 ; j < items.length ; j++ )
+					{
+						instance = items[ j ];
+						if ( instance.clickFn ) CKEDITOR.tools.removeFunction( instance.clickFn );
+						if ( instance.keyDownFn ) CKEDITOR.tools.removeFunction( instance.keyDownFn );
+
+						if ( instance.index ) CKEDITOR.ui.button._.instances[ instance.index ] = null;
+					}
+				}
+			}
+
+			if ( this.contextMenu )
+				CKEDITOR.tools.removeFunction( this.contextMenu._.functionId );
+
+			if ( this._.filebrowserFn )
+				CKEDITOR.tools.removeFunction( this._.filebrowserFn );
+
+			items = editor.config.elementsPath_filters;
+			if ( items )
+			{
+				for ( index= 0 ; index < items.length ; index++ )
+					items[ index ] = null;
+			}
+
 			this.fire( 'destroy' );
 			CKEDITOR.remove( this );
Index: CKEditor/branches/versions/3.3.x/_source/core/editor_basic.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/editor_basic.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/editor_basic.js	(revision 5306)
@@ -37,8 +37,9 @@
 	 * @param {Number} [mode] The mode in which the element is linked to this
 	 *		instance.
+	 * @param {String} [data] Since 3.3. Initial value for the instance.
 	 * @augments CKEDITOR.event
 	 * @example
 	 */
-	CKEDITOR.editor = function( instanceConfig, element, mode )
+	CKEDITOR.editor = function( instanceConfig, element, mode, data )
 	{
 		this._ =
@@ -46,5 +47,6 @@
 			// Save the config to be processed later by the full core code.
 			instanceConfig : instanceConfig,
-			element : element
+			element : element,
+			data : data
 		};
 
@@ -127,8 +129,9 @@
 	 *		editor instance. Configurations set here will override global CKEditor
 	 *		settings.
+	 * @param {String} [data] Since 3.3. Initial value for the instance.
 	 * @returns {CKEDITOR.editor} The editor instance created.
 	 * @example
 	 */
-	CKEDITOR.editor.appendTo = function( elementOrId, config )
+	CKEDITOR.editor.appendTo = function( elementOrId, config, data )
 	{
 		var element = elementOrId;
@@ -142,5 +145,5 @@
 
 		// Create the editor instance.
-		return new CKEDITOR.editor( config, element, CKEDITOR.ELEMENT_MODE_APPENDTO );
+		return new CKEDITOR.editor( config, element, CKEDITOR.ELEMENT_MODE_APPENDTO, data );
 	};
 
Index: CKEditor/branches/versions/3.3.x/_source/core/htmlparser/basicwriter.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/htmlparser/basicwriter.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/htmlparser/basicwriter.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -61,7 +61,7 @@
 		attribute : function( attName, attValue )
 		{
-			// Browsers don't always escape quote in attribute values. (#4683)
+			// Browsers don't always escape special character in attribute values. (#4683, #4719).
 			if ( typeof attValue == 'string' )
-				attValue = attValue.replace( /"/g, '&quot;' );
+				attValue = CKEDITOR.tools.htmlEncodeAttr( attValue ); 
 
 			this._.output.push( ' ', attName, '="', attValue, '"' );
Index: CKEditor/branches/versions/3.3.x/_source/core/htmlparser/cdata.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/htmlparser/cdata.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/htmlparser/cdata.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/core/htmlparser/comment.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/htmlparser/comment.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/htmlparser/comment.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/core/htmlparser/element.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/htmlparser/element.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/htmlparser/element.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/core/htmlparser/filter.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/htmlparser/filter.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/htmlparser/filter.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/core/htmlparser/fragment.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/htmlparser/fragment.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/htmlparser/fragment.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -275,4 +275,5 @@
 
 			checkPending( tagName );
+			sendPendingBRs();
 
 			element.parent = currentNode;
Index: CKEditor/branches/versions/3.3.x/_source/core/imagecacher.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/imagecacher.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/imagecacher.js	(revision 5306)
@@ -12,4 +12,5 @@
 		var doCallback = function()
 			{
+				img.removeAllListeners();
 				loaded[ image ] = 1;
 				callback();
Index: CKEditor/branches/versions/3.3.x/_source/core/plugins.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/plugins.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/plugins.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/core/resourcemanager.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/resourcemanager.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/resourcemanager.js	(revision 5306)
@@ -128,5 +128,5 @@
 		return CKEDITOR.getUrl(
 				this.getPath( name ) +
-				( ( external && external.file !== null ) ? external.file : this.fileName + '.js' ) );
+				( ( external && ( typeof external.file == 'string' ) ) ? external.file : this.fileName + '.js' ) );
 	},
 
Index: CKEditor/branches/versions/3.3.x/_source/core/scriptloader.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/scriptloader.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/scriptloader.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/core/skins.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/skins.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/skins.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/core/tools.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/core/tools.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/core/tools.js	(revision 5306)
@@ -324,4 +324,17 @@
 
 		/**
+		 * Replace special HTML characters in HTMLElement's attribute with their relative HTML entity values.
+		 * @param {String} The attribute's value to be encoded.
+		 * @returns {String} The encode value.
+		 * @example
+		 * element.setAttribute( 'title', '<a " b >' );
+		 * alert( CKEDITOR.tools.htmlEncodeAttr( element.getAttribute( 'title' ) );  // "&gt;a &quot; b &lt;"
+		 */
+		htmlEncodeAttr : function( text ) 
+		{
+			return text.replace( /"/g, '&quot;' ).replace( /</g, '&lt;' ).replace( />/, '&gt;' );
+		},
+		
+		/**
 		 * Replace characters can't be represented through CSS Selectors string
 		 * by CSS Escape Notation where the character escape sequence consists
@@ -541,5 +554,5 @@
 		 * <li> Chainable base class constructor </li>
 		 * </ul>
-		 * @param {Object} definiton The class definiton object.
+		 * @param {Object} definition The class definition object.
 		 * @returns {Function} A class-like JavaScript function.
 		 */
Index: CKEditor/branches/versions/3.3.x/_source/lang/af.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/af.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/lang/af.js	(revision 5306)
@@ -111,9 +111,15 @@
 	},
 
+	contextmenu :
+	{
+		options : 'Context Menu Options' // MISSING
+	},
+
 	// Special char dialog.
 	specialChar		:
 	{
 		toolbar		: 'Spesiaale Karakter byvoeg',
-		title		: 'Kies spesiale karakter'
+		title		: 'Kies spesiale karakter',
+		options : 'Special Character Options' // MISSING
 	},
 
@@ -122,4 +128,5 @@
 	{
 		toolbar		: 'Skakel byvoeg/verander',
+		other 		: '<ander>',
 		menu		: 'Verander skakel',
 		title		: 'Skakel',
@@ -477,10 +484,11 @@
 	{
 		toolbar	: 'Smiley',
-		title	: 'Voeg Smiley by'
+		title	: 'Voeg Smiley by',
+		options : 'Smiley Options' // MISSING
 	},
 
 	elementsPath :
 	{
-		eleLabel : 'Elements path',  // MISSING
+		eleLabel : 'Elements path', // MISSING
 		eleTitle : '%1 element' // MISSING
 	},
@@ -504,7 +512,7 @@
 	{
 		title		: 'Byvoeg',
-		cutError	: 'U browser se sekuriteit instelling behinder die uitsny aksie. Gebruik asseblief die sleutel kombenasie(Ctrl+X).',
-		copyError	: 'U browser se sekuriteit instelling behinder die kopieerings aksie. Gebruik asseblief die sleutel kombenasie(Ctrl+C).',
-		pasteMsg	: 'Voeg asseblief die inhoud in die gegewe box by met sleutel kombenasie(<STRONG>Ctrl+V</STRONG>) en druk <STRONG>OK</STRONG>.',
+		cutError	: 'U browser se sekuriteit instelling behinder die uitsny aksie. Gebruik asseblief die sleutel kombenasie(Ctrl/Cmd+X).',
+		copyError	: 'U browser se sekuriteit instelling behinder die kopieerings aksie. Gebruik asseblief die sleutel kombenasie(Ctrl/Cmd+C).',
+		pasteMsg	: 'Voeg asseblief die inhoud in die gegewe box by met sleutel kombenasie(<STRONG>Ctrl/Cmd+V</STRONG>) en druk <STRONG>OK</STRONG>.',
 		securityMsg	: 'Because of your browser security settings, the editor is not able to access your clipboard data directly. You are required to paste it again in this window.', // MISSING
 		pasteArea	: 'Paste Area' // MISSING
@@ -529,4 +537,5 @@
 		button			: 'Templates',
 		title			: 'Inhoud Templates',
+		options : 'Template Options', // MISSING
 		insertOption	: 'Vervang bestaande inhoud',
 		selectPromptMsg	: 'Kies die template om te gebruik in die editor<br>(Inhoud word vervang!):',
Index: CKEditor/branches/versions/3.3.x/_source/lang/ar.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/ar.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/lang/ar.js	(revision 5306)
@@ -111,9 +111,15 @@
 	},
 
+	contextmenu :
+	{
+		options : 'Context Menu Options' // MISSING
+	},
+
 	// Special char dialog.
 	specialChar		:
 	{
 		toolbar		: 'إدراج  خاص.ِ',
-		title		: 'اختر الخواص'
+		title		: 'اختر الخواص',
+		options : 'Special Character Options' // MISSING
 	},
 
@@ -122,4 +128,5 @@
 	{
 		toolbar		: 'رابط',
+		other 		: '<أخرى>',
 		menu		: 'تحرير رابط',
 		title		: 'إرتباط تشعبي',
@@ -477,10 +484,11 @@
 	{
 		toolbar	: 'ابتسامات',
-		title	: 'إدراج ابتسامات'
+		title	: 'إدراج ابتسامات',
+		options : 'Smiley Options' // MISSING
 	},
 
 	elementsPath :
 	{
-		eleLabel : 'Elements path',  // MISSING
+		eleLabel : 'Elements path', // MISSING
 		eleTitle : 'عنصر 1%'
 	},
@@ -504,7 +512,7 @@
 	{
 		title		: 'لصق',
-		cutError	: 'الإعدادات الأمنية للمتصفح الذي تستخدمه تمنع القص التلقائي. فضلاً إستخدم لوحة المفاتيح لفعل ذلك (Ctrl+X).',
-		copyError	: 'الإعدادات الأمنية للمتصفح الذي تستخدمه تمنع النسخ التلقائي. فضلاً إستخدم لوحة المفاتيح لفعل ذلك (Ctrl+C).',
-		pasteMsg	: 'الصق داخل الصندوق بإستخدام زرائر (<STRONG>Ctrl+V</STRONG>) في لوحة المفاتيح، ثم اضغط زر  <STRONG>موافق</STRONG>.',
+		cutError	: 'الإعدادات الأمنية للمتصفح الذي تستخدمه تمنع القص التلقائي. فضلاً إستخدم لوحة المفاتيح لفعل ذلك (Ctrl/Cmd+X).',
+		copyError	: 'الإعدادات الأمنية للمتصفح الذي تستخدمه تمنع النسخ التلقائي. فضلاً إستخدم لوحة المفاتيح لفعل ذلك (Ctrl/Cmd+C).',
+		pasteMsg	: 'الصق داخل الصندوق بإستخدام زرائر (<STRONG>Ctrl/Cmd+V</STRONG>) في لوحة المفاتيح، ثم اضغط زر  <STRONG>موافق</STRONG>.',
 		securityMsg	: 'نظراً لإعدادات الأمان الخاصة بمتصفحك، لن يتمكن هذا المحرر من الوصول لمحتوى حافظتك، لذلك يجب عليك لصق المحتوى مرة أخرى في هذه النافذة.',
 		pasteArea	: 'Paste Area' // MISSING
@@ -529,4 +537,5 @@
 		button			: 'القوالب',
 		title			: 'قوالب المحتوى',
+		options : 'Template Options', // MISSING
 		insertOption	: 'استبدال المحتوى',
 		selectPromptMsg	: 'اختر القالب الذي تود وضعه في المحرر',
Index: CKEditor/branches/versions/3.3.x/_source/lang/bg.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/bg.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/lang/bg.js	(revision 5306)
@@ -111,9 +111,15 @@
 	},
 
+	contextmenu :
+	{
+		options : 'Context Menu Options' // MISSING
+	},
+
 	// Special char dialog.
 	specialChar		:
 	{
 		toolbar		: 'Вмъкни специален символ',
-		title		: 'Изберете специален символ'
+		title		: 'Изберете специален символ',
+		options : 'Special Character Options' // MISSING
 	},
 
@@ -122,4 +128,5 @@
 	{
 		toolbar		: 'Добави/Редактирай връзка',
+		other 		: '<друг>',
 		menu		: 'Редактирай връзка',
 		title		: 'Връзка',
@@ -477,10 +484,11 @@
 	{
 		toolbar	: 'Усмивка',
-		title	: 'Добави усмивка'
+		title	: 'Добави усмивка',
+		options : 'Smiley Options' // MISSING
 	},
 
 	elementsPath :
 	{
-		eleLabel : 'Elements path',  // MISSING
+		eleLabel : 'Elements path', // MISSING
 		eleTitle : '%1 element' // MISSING
 	},
@@ -504,7 +512,7 @@
 	{
 		title		: 'Вмъкни',
-		cutError	: 'Настройките за сигурност на вашия бразуър не разрешават на редактора да изпълни изрязването. За целта използвайте клавиатурата (Ctrl+X).',
-		copyError	: 'Настройките за сигурност на вашия бразуър не разрешават на редактора да изпълни запаметяването. За целта използвайте клавиатурата (Ctrl+C).',
-		pasteMsg	: 'Вмъкнете тук съдъжанието с клавиатуарата (<STRONG>Ctrl+V</STRONG>) и натиснете <STRONG>OK</STRONG>.',
+		cutError	: 'Настройките за сигурност на вашия бразуър не разрешават на редактора да изпълни изрязването. За целта използвайте клавиатурата (Ctrl/Cmd+X).',
+		copyError	: 'Настройките за сигурност на вашия бразуър не разрешават на редактора да изпълни запаметяването. За целта използвайте клавиатурата (Ctrl/Cmd+C).',
+		pasteMsg	: 'Вмъкнете тук съдъжанието с клавиатуарата (<STRONG>Ctrl/Cmd+V</STRONG>) и натиснете <STRONG>OK</STRONG>.',
 		securityMsg	: 'Because of your browser security settings, the editor is not able to access your clipboard data directly. You are required to paste it again in this window.', // MISSING
 		pasteArea	: 'Paste Area' // MISSING
@@ -529,4 +537,5 @@
 		button			: 'Шаблони',
 		title			: 'Шаблони',
+		options : 'Template Options', // MISSING
 		insertOption	: 'Replace actual contents', // MISSING
 		selectPromptMsg	: 'Изберете шаблон <br>(текущото съдържание на редактора ще бъде загубено):',
